﻿
using System;

using Foundation;
using UIKit;
using Syncfusion.SfDataGrid;
using CoreGraphics;
using System.Collections.ObjectModel;
using System.Reflection;
using System.Linq;
using System.Collections.Generic;

namespace GettingStarted
{
    public partial class GettingStartedViewController : UIViewController
	{
        SfDataGrid grid;
		ViewModel viewModel;
        public GettingStartedViewController()
        {
            grid = new SfDataGrid();
            viewModel = new ViewModel();
            grid.AllowSorting = true;
            grid.AutoGenerateColumns = false;
            grid.ColumnSizer = ColumnSizer.Star;
            viewModel.PopulateData();
            grid.ItemsSource = new QueryableViewExt(viewModel, grid);
            grid.GridTapped += Grid_GridTapped;
            grid.Columns.Add(new GridTextColumn()
            {
                HeaderText = "Order ID",
                MappingName = "Values[orderID]",
                LineBreakMode = UILineBreakMode.WordWrap,
                TextAlignment = UITextAlignment.Left,
                HeaderTextAlignment = UITextAlignment.Center,
            });

            grid.Columns.Add(new GridTextColumn()
            {
                HeaderText = "Customer ID",
                MappingName = "Values[customerID]",
                LineBreakMode = UILineBreakMode.WordWrap,
                TextAlignment = UITextAlignment.Left,
                HeaderTextAlignment = UITextAlignment.Center,
            });

            grid.Columns.Add(new GridTextColumn()
            {
                HeaderText = "First Name",
                MappingName = "Values[firstName]",
                LineBreakMode = UILineBreakMode.WordWrap,
                TextAlignment = UITextAlignment.Left,
                HeaderTextAlignment = UITextAlignment.Center,
            });

            grid.Columns.Add(new GridTextColumn()
            {
                HeaderText = "Last Name",
                MappingName = "Values[lastName]",
                LineBreakMode = UILineBreakMode.WordWrap,
                TextAlignment = UITextAlignment.Left,
                HeaderTextAlignment = UITextAlignment.Center,
            });

            grid.Columns.Add(new GridTextColumn()
            {
                HeaderText = "City",
                MappingName = "Values[city]",
                LineBreakMode = UILineBreakMode.WordWrap,
                TextAlignment = UITextAlignment.Left,
                HeaderTextAlignment = UITextAlignment.Center,
            });
            grid.Columns.Add(new GridTextColumn()
            {
                HeaderText = "GroupProperty",
                MappingName = "GroupProperty",
                Width = 0
            });
            grid.Columns.Add(new GridSwitchColumn()
            {
                HeaderText = "Switch column",
                MappingName = "Values[iSClosed]"
            });

            viewModel.RefreshGroup("firstName");
            this.View.Add(grid);
        }


        public override void ViewDidLayoutSubviews()
        {
            base.ViewDidLayoutSubviews();
            this.grid.Frame = new CGRect(0, 20, View.Frame.Width, View.Frame.Height);
        }

		void Grid_GridTapped(object sender, GridTappedEventsArgs e)
		{
			viewModel.RefreshGroup("lastName");
		}
	}
}

