using System;
using Syncfusion.SfDataGrid;
using System.Collections;
using Syncfusion.Data;
using System.Linq.Expressions;
namespace GettingStarted
{
    public class QueryableViewExt : GridQueryableCollectionViewWrapper
{
    public QueryableViewExt(IEnumerable source, SfDataGrid grid) : base(source, grid)
    {

    }

    public override Expression<Func<string, object, object>> GetExpressionFunc(string propertyName, DataOperation operation = DataOperation.Default, DataReflectionMode reflectionMode = DataReflectionMode.Default)
    {
        Expression<Func<string, object, object>> exp = base.GetExpressionFunc(propertyName, operation, reflectionMode);
        if (exp == null)
        {
            Func<string, object, object> func;
            func = (propertyname, record) =>
             {
                 var provider = this.GetPropertyAccessProvider();
                 return provider.GetValue(record, propertyName);
             };
            exp = (propertyname, record) => func(propertyName, record);
        }
        return exp;
    }
}
}