﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using Newtonsoft.Json;

namespace GettingStarted
{
	public class ViewModel :IEnumerable<DynamicModel>
	{
		public ObservableCollection<DynamicModel> DynamicCollection { get; set; }

		public ViewModel()
		{
			DynamicCollection = PopulateData();
		}
        ObservableCollection<DynamicModel> data;
        public ObservableCollection<DynamicModel> PopulateData()
		{
		   data = new ObservableCollection<DynamicModel>();
            for (int i = 0; i < 30; i++)
            {
                var obj = GetDynamicModel();
                data.Add(obj);
            }
            return data;
		}

		Random r = new Random();

		string[] firstName = new[] { "Gina cjfvbfjfvnjdv", "Katie dvvhvc hug", "Oscar", "Torrey", "Bill", "Frank", "Danielle", "Jack", "Larry", "Holly", "Jennifer", "Pete", "Steve", "Vince", "Zeke" };
		string[] lastName = new[] { "Adams djvn n dn", "Crowley hnld  dhnnkj", "Ellis  nlajk jbl c l nhfn", "Gable", "Irvine", "Keefe", "Mendoza", "Owens", "Rooney", "Waddell", "Thomas", "Betts", "Doran", "Fitzgerald", "Holmes", };
		string[] city = new[] { "Albuquerque bhjdvbhvbh", "Anchorage", "", "Butte", "Elgin", "Eugene", "Kirkland", "Lander", "Portland", "San Francisco", "Seattle", "Walla Walla", "Mannheim", "München", "Münster", };
		string[] orderID = new[] { "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15" };
		string[] customerID = new[] { "111", "222", "333", "444", "555", "666", "777", "888", "999", "1000", "1100", "1200", "1300", "1400", "1500" };
        bool[] iSClosed = new[] { true,false,true,false,true,false,true,false,true, false, false, false, false,true,true };//
		public DynamicModel GetDynamicModel()
		{
			var obj = new DynamicModel();
			obj.Values["orderID"] = orderID[r.Next(0, 14)];
			obj.Values["customerID"] = customerID[r.Next(0, 14)];
			obj.Values["firstName"] = firstName[r.Next(0, 14)];
			obj.Values["lastName"] = lastName[r.Next(0, 14)];
			obj.Values["city"] = city[r.Next(0, 14)];
            obj.Values["iSClosed"] = iSClosed[r.Next(0, 14)];
			return obj;
		}


		public void RefreshGroup(string key)
		{
			foreach (var dynamicItem in this.DynamicCollection)
			{
				dynamicItem.RefreshGroupProperty(key);
			}
		}

        public IEnumerator<DynamicModel> GetEnumerator()
        {
            return data.GetEnumerator();
        }

        IEnumerator IEnumerable.GetEnumerator()
        {
            return this.GetEnumerator();
        }
    }
}
